#ifndef __CH32L103_USBPD_H__
#define __CH32L103_USBPD_H__

#ifdef __cplusplus
extern "C"
{
#endif

#include <FreeRTOS.h>
#include <event_groups.h>
#include <pd.h>
#include <stdbool.h>
#include <stdint.h>

#define BIT(n) (1 << (n))

#define PD_MSG_RECEIVED_EVENT BIT(0)
#define PD_MSG_SENT_EVENT BIT(1)
#define PD_MSG_SEND_FAILED_EVENT BIT(2)

    int ucpd_rx_pending(void);
    uint8_t ucpd_read_message(pd_msg *msg);
    void ucpd_send_message(const pd_msg *msg);
    int ucpd_ch32_init(void);

    EventBits_t ucpd_get_event_bits(void);
    EventBits_t ucpd_clear_event_bits(EventBits_t bits);

#ifdef __cplusplus
}
#endif

#endif /* __CH32L103_USBPD_H */